C $TITLE: 'CMSET'
C $NOFLOATCALLS
      SUBROUTINE CMSET(CM,D,ZARRAY,T1X,T1Y,T1Z,T2X,T2Y,T2Z,X,Y,Z,BI,
     1 SALP,ICON1,ICON2,ICONX,NROW,LD,LD2,IRESRV)
C
C     CMSET SETS UP THE COMPLEX STRUCTURE MATRIX IN THE ARRAY CM
C
      INTEGER*4 ICON1,ICON2,ICONX,N1,N2,N,NP,M1,M2,M,MP,IPSYM
      INTEGER*4 I,J,K,KA,KK,IT
      INTEGER*4 NROW,IDM1,IOUT,IND1,IND2,I1,I2,IN1,IN2,IM1,IM2,JM1,JM2
      INTEGER*4 IMAT,NPBLK,NLAST,NLSYM,NBBX,NPBX,NLBX,NBBL,NPBL,NLBL
      REAL*8 AX,BX,CX
CLARGE: CM
      COMPLEX CM
      COMPLEX*16 D,DETER
      COMPLEX*16 EXK,EYK,EZK,EXS,EYS,EZS,EXC,EYC,EZC,ZAJ
      COMPLEX*16 ZARRAY,SSX
      COMMON/DATAD/N1,N2,N,NP,M1,M2,M,MP,IPSYM,WLAM
      COMMON/MATPAR/ICASE,NBLOKS,NPBLK,NLAST,NBLSYM,NPSYM,NLSYM,IMAT,
     1 ICASX,NBBX,NPBX,NLBX,NBBL,NPBL,NLBL
      COMMON/SMAT/ SSX(16,16)
      COMMON/ZLOAD/ NLOAD,NLODF
      COMMON/SEGJ/AX(30),BX(30),CX(30),JCO(30),JSNO,ISCON(50),NSCON,
     1 IPCON(10),NPCON
      COMMON/DATAJ/S,B,XJ,YJ,ZJ,CABJ,SABJ,SALPJ,EXK,EYK,EZK,EXS,EYS,
     1 EZS,EXC,EYC,EZC,RKH,IND1,IND2,IPGND,IEXK
      DIMENSION CM(NROW,1),D(LD2),ICON1(LD),ICON2(LD),ICONX(LD)
      DIMENSION ZARRAY(LD),X(LD),Y(LD),Z(LD),BI(LD),SALP(LD)
      DIMENSION T1X(LD),T1Y(LD),T1Z(LD),T2X(LD),T2Y(LD),T2Z(LD)
C**
C     D      WRITE(*,*) '  CMSET: START'
      IRESRV=IRESRV
C**
      MP2=2*MP
      NPEQ=NP+MP2
      NEQ=N+2*M
      NOP=NEQ/NPEQ
      IF (ICASE.GT.2) REWIND 11
C**   RKH=RKHX
C**   IEXK=IEXKX
      IOUT=2*NPBLK*NROW
      IT=NPBLK
      IDM1=1
C
C     CYCLE OVER MATRIX BLOCKS
C
      DO 13 IXBLK1=1,NBLOKS
      ISV=(IXBLK1-1)*NPBLK
      IF (IXBLK1.EQ.NBLOKS) IT=NLAST
      DO 1 I=1,NROW
      DO 1 J=1,IT
1     CM(I,J)=CMPLX(0.,0.)
      I1=ISV+1
      I2=ISV+IT
      IN2=I2
      IF (IN2.GT.NP) IN2=NP
      IM1=I1-NP
      IM2=I2-NP
      IF (IM1.LT.1) IM1=1
      IST=1
      IF (I1.LE.NP) IST=NP-I1+2
      IF (N.EQ.0) GO TO 5
C
C     WIRE SOURCE LOOP
C
      DO 4 J=1,N
      CALL TRIO(T1X,BI,ICON1,ICON2,J,LD)
      DO 2 I=1,JSNO
      IJ=JCO(I)
2     JCO(I)=((IJ-1)/NP)*MP2+IJ
      IF (I1.LE.IN2) CALL CMWW(CM,CM,X,Y,Z,BI,SALP,T1X,T1Y,T1Z,
     1 ICON1,ICON2,NROW,NROW,J,I1,IN2,1,LD)
      IF(IM1.LE.IM2) CALL CMWS(CM(1,IST),CM,X,Y,Z,BI,SALP,T1X,T1Y,
     1 T1Z,T2X,T2Y,T2Z,NROW,NROW,J,IM1,IM2,1,LD)
      IF (NLOAD.EQ.0) GO TO 4
C
C     MATRIX ELEMENTS MODIFIED BY LOADING
C
      IF (J.GT.NP) GO TO 4
      IPR=J-ISV
      IF (IPR.LT.1.OR.IPR.GT.IT) GO TO 4
      ZAJ=ZARRAY(J)
      DO 3 I=1,JSNO
      JSS=JCO(I)
      CM(JSS,IPR)=CM(JSS,IPR)-(AX(I)+CX(I))*ZAJ
3      CONTINUE
4     CONTINUE
5     IF (M.EQ.0) GO TO 7
C     MATRIX ELEMENTS FOR PATCH CURRENT SOURCES
      JM1=1-MP
      JM2=0
      JST=1-MP2
      DO 6 I=1,NOP
      JM1=JM1+MP
      JM2=JM2+MP
      JST=JST+NPEQ
      IF (I1.LE.IN2) CALL CMSW(CM(JST,1),CM,X,Y,Z,BI,SALP,T1X,T1Y,
     1 T1Z,T2X,T2Y,T2Z,ICON1,ICON2,ICONX,JM1,JM2,I1,IN2,NROW,0,1,LD)
      IF (IM1.LE.IM2) CALL CMSS(CM(JST,IST),X,Y,Z,BI,SALP,
     1 T1X,T1Y,T1Z,T2X,T2Y,T2Z,JM1,JM2,IM1,IM2,NROW,1,LD)
6     CONTINUE
7     IF (ICASE.EQ.1) GO TO 13
      IF (ICASE.EQ.3) GO TO 12
C     COMBINE ELEMENTS FOR SYMMETRY MODES
      DO 11 I=1,IT
      DO 11 J=1,NPEQ
      DO 8 K=1,NOP
      KA=J+(K-1)*NPEQ
8     D(K)=CM(KA,I)
      DETER=D(1)
      DO 9 KK=2,NOP
9     DETER=DETER+D(KK)
      CM(J,I)=DETER
      DO 11 K=2,NOP
      KA=J+(K-1)*NPEQ
      DETER=D(1)
      DO 10 KK=2,NOP
      DETER=DETER+D(KK)*SSX(K,KK)
10      CONTINUE
      CM(KA,I)=DETER
11    CONTINUE
      IF (ICASE.LT.3) GO TO 13
C     WRITE BLOCK FOR OUT-OF-CORE CASES.
12    CALL BLCKOT (CM,IDM1,IOUT,1,31,11)
13    CONTINUE
      IF (ICASE.GT.2) REWIND 11
C**
C     D      WRITE(*,*) '  CMSET: RETURN'
C**
      RETURN
      END
C
C
C
      SUBROUTINE CMNGF(CB,CC,CD,ZARRAY,T1X,T1Y,T1Z,T2X,T2Y,T2Z,
     1 X,Y,Z,BI,SALP,RKHX,ICON1,ICON2,ICONX,NB,NC,ND,IEXKX,LD)
C     CMNGF FILLS INTERACTION MATRICIES B, C, AND D FOR N.G.F. SOLUTION
      REAL*8 AX,BX,CX
CLARGE: CB,CC,CD
      COMPLEX CB,CC,CD
      COMPLEX*16 EXK,EYK,EZK,EXS,EYS,EZS,EXC,EYC,EZC
      COMPLEX*16 ZARRAY
C** IDM1 IS INTEGER*4 DUMMY VARIABLE
C** IDM2 IS INTEGER*4 OR *2 DEPENDING ON $STORAGE SETTING
      INTEGER*4 ICON1,ICON2,ICONX,N1,N2,N,NP,M1,M2,M,MP,IPSYM,I1,I2
      INTEGER*4 IND1,IND2,IN1,IN2,I,J,IR,IDM1,NB,NC,ND,MEQ,
     2 M1EQ,M2EQ,IM1,IM2
      INTEGER*4 IMAT,NPBLK,NLAST,NLSYM,NBBX,NPBX,NLBX,NBBL,NPBL,NLBL
      COMMON/DATAD/N1,N2,N,NP,M1,M2,M,MP,IPSYM,WLAM
      COMMON/ZLOAD/ NLOAD,NLODF
      COMMON/SEGJ/AX(30),BX(30),CX(30),JCO(30),JSNO,ISCON(50),NSCON,
     1 IPCON(10),NPCON
      COMMON/DATAJ/S,B,XJ,YJ,ZJ,CABJ,SABJ,SALPJ,EXK,EYK,EZK,EXS,EYS,
     1 EZS,EXC,EYC,EZC,RKH,IND1,IND2,IPGND,IEXK
      COMMON/MATPAR/ICASE,NBLOKS,NPBLK,NLAST,NBLSYM,NPSYM,NLSYM,IMAT,
     1 ICASX,NBBX,NPBX,NLBX,NBBL,NPBL,NLBL
      DIMENSION CB(NB,1),CC(NC,1),CD(ND,1),ICON1(LD),ICON2(LD),
     1 ICONX(LD)
      DIMENSION ZARRAY(LD),X(LD),Y(LD),Z(LD),BI(LD),SALP(LD)
      DIMENSION T1X(LD),T1Y(LD),T1Z(LD),T2X(LD),T2Y(LD),T2Z(LD)
C**
C     D      WRITE(*,*) '  CMNGF: START'
C**
      RKH=RKHX
      IEXK=IEXKX
      M1EQ=2*M1
      M2EQ=M1EQ+1
      MEQ=2*M
      NEQP=ND-NPCON*2
      NEQS=NEQP-NSCON
      NEQSP=NEQS+NC
      NEQN=NC+N-N1
      ITX=1
      IF (NSCON.GT.0) ITX=2
      IF (ICASX.EQ.1) GO TO 1
      REWIND 12
      REWIND 14
      REWIND 15
      IF (ICASX.GT.2) GO TO 5
1     DO 4 J=1,ND
      DO 2 I=1,ND
2     CD(I,J)=(0.,0.)
      DO 3 I=1,NB
      CB(I,J)=(0.,0.)
3     CC(I,J)=(0.,0.)
4     CONTINUE
5     IST=N-N1+1
      IT=NPBX
      ISV=-NPBX
C     LOOP THRU 24 FILLS B.  FOR ICASX=1 OR 2 ALSO FILLS D(WW), D(WS)
      DO 24 IBLK=1,NBBX
      ISV=ISV+NPBX
      IF (IBLK.EQ.NBBX) IT=NLBX
      IF (ICASX.LT.3) GO TO 7
      DO 6 J=1,ND
      DO 6 I=1,IT
6     CB(I,J)=(0.,0.)
7     I1=ISV+1
      I2=ISV+IT
      IN2=I2
      IF (IN2.GT.N1) IN2=N1
      IM1=I1-N1
      IM2=I2-N1
      IF (IM1.LT.1) IM1=1
      IMX=1
      IF (I1.LE.N1) IMX=N1-I1+2
      IF (N2.GT.N) GO TO 12
C     FILL B(WW),B(WS).  FOR ICASX=1,2 FILL D(WW),D(WS)
      DO 11 J=N2,N
      CALL TRIO(T1X,BI,ICON1,ICON2,J,LD)
      DO 9 I=1,JSNO
      JSS=JCO(I)
      IF (JSS.LT.N2) GO TO 8
C     SET JCO WHEN SOURCE IS NEW BASIS FUNCTION ON NEW SEGMENT
      JCO(I)=JSS-N1
      GO TO 9
C     SOURCE IS PORTION OF MODIFIED BASIS FUNCTION ON NEW SEGMENT
8     JCO(I)=NEQS+ICONX(JSS)
9     CONTINUE
      IF (I1.LE.IN2) CALL CMWW(CB,CB,X,Y,Z,BI,SALP,T1X,T1Y,T1Z,
     1 ICON1,ICON2,NB,NB,J,I1,IN2,0,LD)
      IF (IM1.LE.IM2) CALL CMWS(CB(IMX,1),CB,X,Y,Z,BI,SALP,T1X,T1Y,
     1 T1Z,T2X,T2Y,T2Z,NB,NB,J,IM1,IM2,0,LD)
      IF (ICASX.GT.2) GO TO 11
      CALL CMWW(CD,CD,X,Y,Z,BI,SALP,T1X,T1Y,T1Z,ICON1,ICON2,
     1 ND,ND,J,N2,N,1,LD)
      IF (M2.LE.M) CALL CMWS(CD(1,IST),CD,X,Y,Z,BI,SALP,T1X,T1Y,T1Z,
     1 T2X,T2Y,T2Z,ND,ND,J,M2EQ,MEQ,1,LD)
C     LOADING IN D(WW)
      IF (NLOAD.EQ.0) GO TO 11
      IR=J-N1
      EXK=ZARRAY(J)
      DO 10 I=1,JSNO
      JSS=JCO(I)
10    CD(JSS,IR)=CD(JSS,IR)-(AX(I)+CX(I))*EXK
11    CONTINUE
12    IF (NSCON.EQ.0) GO TO 20
C     FILL B(WW)PRIME
      DO 19 I=1,NSCON
      J=ISCON(I)
C     SOURCES ARE NEW OR MODIFIED BASIS FUNCTIONS ON OLD SEGMENTS WHICH
C     CONNECT TO NEW SEGMENTS
      CALL TRIO(T1X,BI,ICON1,ICON2,J,LD)
      JSS=0
      DO 15 IX=1,JSNO
      IR=JCO(IX)
      IF (IR.LT.N2) GO TO 13
      IR=IR-N1
      GO TO 14
13    IR=ICONX(IR)
      IF (IR.EQ.0) GO TO 15
      IR=NEQS+IR
14    JSS=JSS+1
      JCO(JSS)=IR
      AX(JSS)=AX(IX)
      BX(JSS)=BX(IX)
      CX(JSS)=CX(IX)
15    CONTINUE
      JSNO=JSS
      IF (I1.LE.IN2) CALL CMWW(CB,CB,X,Y,Z,BI,SALP,T1X,T1Y,T1Z,
     1 ICON1,ICON2,NB,NB,J,I1,IN2,0,LD)
      IF (IM1.LE.IM2) CALL CMWS(CB(IMX,1),CB,X,Y,Z,BI,SALP,T1X,T1Y,
     1 T1Z,T2X,T2Y,T2Z,NB,NB,J,IM1,IM2,0,LD)
C     SOURCE IS SINGULAR COMPONENT OF PATCH CURRENT THAT IS PART OF
C     MODIFIED BASIS FUNCTION FOR OLD SEGMENT THAT CONNECTS TO A NEW
C     SEGMENT ON END OPPOSITE PATCH.
      IF (I1.LE.IN2) CALL CMSW(CB,CB,X,Y,Z,BI,SALP,T1X,T1Y,T1Z,
     1 T2X,T2Y,T2Z,ICON1,ICON2,ICONX,J,I,I1,IN2,NB,0,-1,LD)
      IF (NLODF.EQ.0) GO TO 17
      JX=J-ISV
      IF (JX.LT.1.OR.JX.GT.IT) GO TO 17
      EXK=ZARRAY(J)
      DO 16 IX=1,JSNO
      JSS=JCO(IX)
16    CB(JX,JSS)=CB(JX,JSS)-(AX(IX)+CX(IX))*EXK
C     SOURCES ARE PORTIONS OF MODIFIED BASIS FUNCTION J ON OLD SEGMENTS
C     EXCLUDING OLD SEGMENTS THAT DIRECTLY CONNECT TO NEW SEGMENTS.
17      CONTINUE
      IDM2=J
      CALL TBF (T1X,BI,ICON1,ICON2,1,IDM2,LD)
      JSX=JSNO
      JSNO=1
      IR=JCO(1)
      JCO(1)=NEQS+I
      DO 19 IX=1,JSX
      IF (IX.EQ.1) GO TO 18
      IR=JCO(IX)
      AX(1)=AX(IX)
      BX(1)=BX(IX)
      CX(1)=CX(IX)
18    IF (IR.GT.N1) GO TO 19
      IF (ICONX(IR).NE.0) GO TO 19
      IF (I1.LE.IN2) CALL CMWW(CB,CB,X,Y,Z,BI,SALP,T1X,T1Y,T1Z,
     1 ICON1,ICON2,NB,NB,IR,I1,IN2,0,LD)
      IF (IM1.LE.IM2) CALL CMWS(CB(IMX,1),CB,X,Y,Z,BI,SALP,T1X,T1Y,
     1 T1Z,T2X,T2Y,T2Z,NB,NB,IR,IM1,IM2,0,LD)
C     LOADING FOR B(WW)PRIME
      IF (NLODF.EQ.0) GO TO 19
      JX=IR-ISV
      IF (JX.LT.1.OR.JX.GT.IT) GO TO 19
      EXK=ZARRAY(IR)
      JSS=JCO(1)
      CB(JX,JSS)=CB(JX,JSS)-(AX(1)+CX(1))*EXK
19    CONTINUE
20    IF (NPCON.EQ.0) GO TO 22
      JSS=NEQP
C     FILL B(SS)PRIME TO SET OLD PATCH BASIS FUNCTIONS TO ZERO FOR
C     PATCHES THAT CONNECT TO NEW SEGMENTS
      DO 21 I=1,NPCON
      IX=IPCON(I)*2+N1-ISV
      IR=IX-1
      JSS=JSS+1
      IF (IR.GT.0.AND.IR.LE.IT) CB(IR,JSS)=(1.,0.)
      JSS=JSS+1
      IF (IX.GT.0.AND.IX.LE.IT) CB(IX,JSS)=(1.,0.)
21    CONTINUE
22    IF (M2.GT.M) GO TO 23
C     FILL B(SW) AND B(SS)
      IDM2=N1
      IF (I1.LE.IN2) CALL CMSW(CB(1,IST),CB,X,Y,Z,BI,SALP,T1X,T1Y,
     1 T1Z,T2X,T2Y,T2Z,ICON1,ICON2,ICONX,M2,M,I1,IN2,NB,IDM2,0,LD)
      IF (IM1.LE.IM2) CALL CMSS(CB(IMX,IST),X,Y,Z,BI,SALP,
     1 T1X,T1Y,T1Z,T2X,T2Y,T2Z,M2,M,IM1,IM2,NB,0,LD)
23    IF (ICASX.EQ.1) GO TO 24
      WRITE (14) ((CB(I,J),I=1,IT),J=1,ND)
24    CONTINUE
C     FILLING B COMPLETE.  START ON C AND D
      IT=NPBL
      ISV=-NPBL
      DO 43 IBLK=1,NBBL
      ISV=ISV+NPBL
      ISVV=ISV+NC
      IF (IBLK.EQ.NBBL) IT=NLBL
      IF (ICASX.LT.3) GO TO 27
      DO 26 J=1,IT
      DO 25 I=1,NC
25    CC(I,J)=(0.,0.)
      DO 26 I=1,ND
26    CD(I,J)=(0.,0.)
27    I1=ISVV+1
      I2=ISVV+IT
      IN1=I1-M1EQ
      IN2=I2-M1EQ
      IF (IN2.GT.N) IN2=N
      IM1=I1-N
      IM2=I2-N
      IF (IM1.LT.M2EQ) IM1=M2EQ
      IF (IM2.GT.MEQ) IM2=MEQ
      IMX=1
      IF (IN1.LE.IN2) IMX=NEQN-I1+2
      IF (ICASX.LT.3) GO TO 32
      IF (N2.GT.N) GO TO 32
C     SAME AS DO 24 LOOP TO FILL D(WW) FOR ICASX GREATER THAN 2
      DO 31 J=N2,N
      CALL TRIO(T1X,BI,ICON1,ICON2,J,LD)
      DO 29 I=1,JSNO
      JSS=JCO(I)
      IF (JSS.LT.N2) GO TO 28
      JCO(I)=JSS-N1
      GO TO 29
28    JCO(I)=NEQS+ICONX(JSS)
29    CONTINUE
      IF (IN1.LE.IN2) CALL CMWW(CD,CD,X,Y,Z,BI,SALP,T1X,T1Y,T1Z,
     1 ICON1,ICON2,ND,ND,J,IN1,IN2,1,LD)
      IF (IM1.LE.IM2) CALL CMWS(CD(1,IMX),CD,X,Y,Z,BI,SALP,T1X,T1Y,
     1 T1Z,T2X,T2Y,T2Z,ND,ND,J,IM1,IM2,1,LD)
      IF (NLOAD.EQ.0) GO TO 31
      IR=J-N1-ISV
      IF (IR.LT.1.OR.IR.GT.IT) GO TO 31
      EXK=ZARRAY(J)
      DO 30 I=1,JSNO
      JSS=JCO(I)
30    CD(JSS,IR)=CD(JSS,IR)-(AX(I)+CX(I))*EXK
31    CONTINUE
32    IF (M2.GT.M) GO TO 33
C     FILL D(SW) AND D(SS)
      IDM2=N1
      IF (IN1.LE.IN2) CALL CMSW(CD(IST,1),CD,X,Y,Z,BI,SALP,T1X,T1Y,
     1 T1Z,T2X,T2Y,T2Z,ICON1,ICON2,ICONX,M2,M,IN1,IN2,ND,IDM2,1,LD)
      IF (IM1.LE.IM2) CALL CMSS(CD(IST,IMX),X,Y,Z,BI,SALP,
     1 T1X,T1Y,T1Z,T2X,T2Y,T2Z,M2,M,IM1,IM2,ND,1,LD)
33    IF (N1.LT.1) GO TO 39
C     FILL C(WW),C(WS), D(WW)PRIME, AND D(WS)PRIME.
      DO 37 J=1,N1
      CALL TRIO(T1X,BI,ICON1,ICON2,J,LD)
      IF (NSCON.EQ.0) GO TO 36
      DO 35 IX=1,JSNO
      JSS=JCO(IX)
      IF (JSS.LT.N2) GO TO 34
      JCO(IX)=JSS+M1EQ
      GO TO 35
34    IR=ICONX(JSS)
      IF (IR.NE.0) JCO(IX)=NEQSP+IR
35    CONTINUE
36    IF (IN1.LE.IN2) CALL CMWW(CC,CD,X,Y,Z,BI,SALP,T1X,T1Y,T1Z,
     1 ICON1,ICON2,NC,ND,J,IN1,IN2,ITX,LD)
      IF (IM1.LE.IM2) CALL CMWS(CC(1,IMX),CD(1,IMX),X,Y,Z,BI,SALP,
     1 T1X,T1Y,T1Z,T2X,T2Y,T2Z,NC,ND,J,IM1,IM2,ITX,LD)
37    CONTINUE
      IF (NSCON.EQ.0) GO TO 39
C     FILL C(WW)PRIME
      DO 38 IX=1,NSCON
      IR=ISCON(IX)
      JSS=NEQS+IX-ISV
      IF (JSS.GT.0.AND.JSS.LE.IT) CC(IR,JSS)=(1.,0.)
38    CONTINUE
39      CONTINUE
      IF (NPCON.EQ.0) GO TO 41
      JSS=NEQP-ISV
C     FILL C(SS)PRIME
      DO 40 I=1,NPCON
      IX=IPCON(I)*2+N1
      IR=IX-1
      JSS=JSS+1
      IF (JSS.GT.0.AND.JSS.LE.IT) CC(IR,JSS)=(1.,0.)
      JSS=JSS+1
      IF (JSS.GT.0.AND.JSS.LE.IT) CC(IX,JSS)=(1.,0.)
40    CONTINUE
41      CONTINUE
      IF (M1.LT.1) GO TO 42
C     FILL C(SW) AND C(SS)
      IDM1=1
      IF (IN1.LE.IN2) CALL CMSW(CC(N2,1),CC,X,Y,Z,BI,SALP,T1X,T1Y,
     1 T1Z,T2X,T2Y,T2Z,ICON1,ICON2,ICONX,IDM1,M1,IN1,IN2,NC,0,1,LD)
      IDM1=1
      IF (IM1.LE.IM2) CALL CMSS(CC(N2,IMX),X,Y,Z,BI,SALP,
     1 T1X,T1Y,T1Z,T2X,T2Y,T2Z,IDM1,M1,IM1,IM2,NC,1,LD)
42    CONTINUE
      IF (ICASX.EQ.1) GO TO 43
      WRITE (12) ((CD(J,I),J=1,ND),I=1,IT)
      WRITE (15) ((CC(J,I),J=1,NC),I=1,IT)
43    CONTINUE
C**
C     D      WRITE(*,*) '  CMNGF: RETURN'
C**
      IF(ICASX.EQ.1)RETURN
      REWIND 12
      REWIND 14
      REWIND 15
      RETURN
      END
C
C
C
      SUBROUTINE CMWW(CM,CW,X,Y,Z,BI,SALP,T1X,T1Y,T1Z,ICON1,ICON2,
     1 NR,NW,J,I1,I2,ITRP,LD)
C
C     CMWW COMPUTES MATRIX ELEMENTS FOR WIRE-WIRE INTERACTIONS
C
      INTEGER*4 ICON1,ICON2,N1,N2,N,NP,M1,M2,M,MP,IPSYM,IND1,IND2,
     1 I1,I2,I,J,NR,NW
      REAL*8 XI,YI,ZI,AX,BX,CX
CLARGE: CM,CW
      COMPLEX CM,CW
      COMPLEX*16 ETK,ETS,ETC,EXK,EYK,EZK,EXS,EYS,EZS,EXC,EYC,EZC
      COMMON/DATAD/N1,N2,N,NP,M1,M2,M,MP,IPSYM,WLAM
      COMMON/SEGJ/AX(30),BX(30),CX(30),JCO(30),JSNO,ISCON(50),NSCON,
     1 IPCON(10),NPCON
      COMMON/DATAJ/S,B,XJ,YJ,ZJ,CABJ,SABJ,SALPJ,EXK,EYK,EZK,EXS,EYS,
     1 EZS,EXC,EYC,EZC,RKH,IND1,IND2,IPGND,IEXK
      DIMENSION CM(NR,1),CW(NW,1),ICON1(LD),ICON2(LD)
      DIMENSION X(LD),Y(LD),Z(LD),BI(LD),SALP(LD)
      DIMENSION T1X(LD),T1Y(LD),T1Z(LD)
C     SET SOURCE SEGMENT PARAMETERS
C**
C     E      WRITE(*,*) '   CMWW: START'
      LD=LD
C**
      S=T1X(J)
      B=BI(J)
      XJ=X(J)
      YJ=Y(J)
      ZJ=Z(J)
      CABJ=T1Y(J)
      SABJ=T1Z(J)
      SALPJ=SALP(J)
      IF (IEXK.EQ.0) GO TO 16
C     DECIDE WETHER EXT. T.W. APPROX. CAN BE USED
      IPR=ICON1(J)
      IF (IPR) 1,6,2
1     IPR=-IPR
      IF (-ICON1(IPR).NE.J) GO TO 7
      GO TO 4
2     IF (IPR.NE.J) GO TO 3
      IF (CABJ*CABJ+SABJ*SABJ.GT.1.E-8) GO TO 7
      GO TO 5
3     IF (ICON2(IPR).NE.J) GO TO 7
4     XI=ABS(CABJ*T1Y(IPR)+SABJ*T1Z(IPR)+SALPJ*SALP(IPR))
      IF (XI.LT.0.999999) GO TO 7
      IF (ABS(BI(IPR)/B-1.).GT.1.E-6) GO TO 7
5     IND1=0
      GO TO 8
6     IND1=1
      GO TO 8
7     IND1=2
8     IPR=ICON2(J)
      IF (IPR) 9,14,10
9     IPR=-IPR
      IF (-ICON2(IPR).NE.J) GO TO 15
      GO TO 12
10    IF (IPR.NE.J) GO TO 11
      IF (CABJ*CABJ+SABJ*SABJ.GT.1.E-8) GO TO 15
      GO TO 13
11    IF (ICON1(IPR).NE.J) GO TO 15
12    XI=ABS(CABJ*T1Y(IPR)+SABJ*T1Z(IPR)+SALPJ*SALP(IPR))
      IF (XI.LT.0.999999) GO TO 15
      IF (ABS(BI(IPR)/B-1.).GT.1.E-6) GO TO 15
13    IND2=0
      GO TO 16
14    IND2=1
      GO TO 16
15    IND2=2
16    CONTINUE
C
C     OBSERVATION LOOP
C
      IPR=0
      DO 23 I=I1,I2
      IPR=IPR+1
      IJ=I-J
      XI=X(I)
      YI=Y(I)
      ZI=Z(I)
      AI=BI(I)
      CABI=T1Y(I)
      SABI=T1Z(I)
      SALPI=SALP(I)
      CALL EFLD (XI,YI,ZI,AI,IJ)
      ETK=EXK*CABI+EYK*SABI+EZK*SALPI
      ETS=EXS*CABI+EYS*SABI+EZS*SALPI
      ETC=EXC*CABI+EYC*SABI+EZC*SALPI
C
C     FILL MATRIX ELEMENTS.  ELEMENT LOCATIONS DETERMINED BY CONNECTION
C     DATA.
C
      IF (ITRP.NE.0) GO TO 18
C     NORMAL FILL
      DO 17 IJ=1,JSNO
      JX=JCO(IJ)
      CM(IPR,JX)=CM(IPR,JX)+ETK*AX(IJ)+ETS*BX(IJ)+ETC*CX(IJ)
17      CONTINUE
      GO TO 23
18      CONTINUE
      IF (ITRP.EQ.2) GO TO 20
C     TRANSPOSED FILL
      DO 19 IJ=1,JSNO
      JX=JCO(IJ)
      CM(JX,IPR)=CM(JX,IPR)+ETK*AX(IJ)+ETS*BX(IJ)+ETC*CX(IJ)
19      CONTINUE
      GO TO 23
C     TRANS. FILL FOR C(WW) - TEST FOR ELEMENTS FOR D(WW)PRIME.  (=CW)
20      CONTINUE
      DO 22 IJ=1,JSNO
      JX=JCO(IJ)
      IF (JX.GT.NR) GO TO 21
      CM(JX,IPR)=CM(JX,IPR)+ETK*AX(IJ)+ETS*BX(IJ)+ETC*CX(IJ)
      GO TO 22
21    JX=JX-NR
      CW(JX,IPR)=CW(JX,IPR)+ETK*AX(IJ)+ETS*BX(IJ)+ETC*CX(IJ)
22    CONTINUE
23    CONTINUE
C**
C     E      WRITE(*,*) '   CMWW: RETURN'
C**
      RETURN
      END
C
C
C
      SUBROUTINE CMSS(CM,X,Y,Z,BI,SALP,T1X,T1Y,T1Z,T2X,T2Y,T2Z,
     1 J1,J2,IM1,IM2,NROW,ITRP,LD)
C     CMSS COMPUTES MATRIX ELEMENTS FOR SURFACE-SURFACE INTERACTIONS.
      INTEGER*4 N1,N2,N,NP,M1,M2,M,MP,IPSYM,IND1,IND2,J1,J2,NROW,
     1 IM1,IM2
      REAL*8 XI,YI,ZI
CLARGE: CM
      COMPLEX CM
      COMPLEX*16 G11,G12,G21,G22,EXK,EYK,EZK,EXS,EYS,EZS,EXC,EYC,EZC
      COMMON/DATAD/N1,N2,N,NP,M1,M2,M,MP,IPSYM,WLAM
      COMMON/DATAJ/S,B,XJ,YJ,ZJ,CABJ,SABJ,SALPJ,EXK,EYK,EZK,EXS,EYS,
     1 EZS,EXC,EYC,EZC,RKH,IND1,IND2,IPGND,IEXK
      DIMENSION CM(NROW,1)
      DIMENSION X(LD),Y(LD),Z(LD),BI(LD),SALP(LD)
      DIMENSION T1X(LD),T1Y(LD),T1Z(LD),T2X(LD),T2Y(LD),T2Z(LD)
      EQUIVALENCE (T1XJ,CABJ),(T1YJ,SABJ),(T1ZJ,SALPJ),(T2XJ,B),
     1 (T2YJ,IND1), (T2ZJ,IND2)
C**
C     E      WRITE(*,*) '   CMSS: START'
C**
      LDP=LD+1
      I1=(IM1+1)/2
      I2=(IM2+1)/2
      ICOMP=I1*2-3
      II1=-1
      IF (ICOMP+2.LT.IM1) II1=-2
C     LOOP OVER OBSERVATION PATCHES
      DO 5 I=I1,I2
      IL=LDP-I
      ICOMP=ICOMP+2
      II1=II1+2
      II2=II1+1
      T1XI=T1X(IL)*SALP(IL)
      T1YI=T1Y(IL)*SALP(IL)
      T1ZI=T1Z(IL)*SALP(IL)
      T2XI=T2X(IL)*SALP(IL)
      T2YI=T2Y(IL)*SALP(IL)
      T2ZI=T2Z(IL)*SALP(IL)
      XI=X(IL)
      YI=Y(IL)
      ZI=Z(IL)
      JJ1=-1
C     LOOP OVER SOURCE PATCHES
      DO 5 J=J1,J2
      JL=LDP-J
      JJ1=JJ1+2
      JJ2=JJ1+1
      S=BI(JL)
      XJ=X(JL)
      YJ=Y(JL)
      ZJ=Z(JL)
      T1XJ=T1X(JL)
      T1YJ=T1Y(JL)
      T1ZJ=T1Z(JL)
      T2XJ=T2X(JL)
      T2YJ=T2Y(JL)
      T2ZJ=T2Z(JL)
      CALL HINTG (XI,YI,ZI)
      G11=-(T2XI*EXK+T2YI*EYK+T2ZI*EZK)
      G12=-(T2XI*EXS+T2YI*EYS+T2ZI*EZS)
      G21=-(T1XI*EXK+T1YI*EYK+T1ZI*EZK)
      G22=-(T1XI*EXS+T1YI*EYS+T1ZI*EZS)
      IF (I.NE.J) GO TO 1
      G11=G11-.5
      G22=G22+.5
1     IF (ITRP.NE.0) GO TO 3
C     NORMAL FILL
      IF (ICOMP.LT.IM1) GO TO 2
      CM(II1,JJ1)=G11
      CM(II1,JJ2)=G12
2     IF (ICOMP.GE.IM2) GO TO 5
      CM(II2,JJ1)=G21
      CM(II2,JJ2)=G22
      GO TO 5
C     TRANSPOSED FILL
3     IF (ICOMP.LT.IM1) GO TO 4
      CM(JJ1,II1)=G11
      CM(JJ2,II1)=G12
4     IF (ICOMP.GE.IM2) GO TO 5
      CM(JJ1,II2)=G21
      CM(JJ2,II2)=G22
5     CONTINUE
C**
C     E      WRITE(*,*) '   CMSS: RETURN'
C**
      RETURN
      END
C
C
C
      SUBROUTINE CMSW(CM,CW,X,Y,Z,BI,SALP,T1X,T1Y,T1Z,T2X,T2Y,T2Z,
     1 ICON1,ICON2,ICONX,J1,J2,I1,I2,NROW,NCW,ITRP,LD)
C     COMPUTES MATRIX ELEMENTS FOR E ALONG WIRES DUE TO PATCH CURRENT
      INTEGER*4 ICON1,ICON2,ICONX
      INTEGER*4 N1,N2,N,NP,M1,M2,M,MP,IPSYM,IND1,IND2,I1,I2,J1,J2,
     1 I,J,NROW
      REAL*8 PI,XI,YI,ZI,AX,BX,CX
CLARGE: CM,CW
      COMPLEX CM,CW
      COMPLEX*16 ZRATI,ZRATI2,T1,EXK,EYK,EZK,EXS,EYS,EZS,EXC,EYC,EZC,
     1 FRATI
      COMPLEX*16 EMEL
      COMMON/DATAD/N1,N2,N,NP,M1,M2,M,MP,IPSYM,WLAM
      COMMON/GND/ZRATI,ZRATI2,FRATI,CL,CH,SCRWL,SCRWR,NRADL,KSYMP,
     1 IFAR,IPERF,T1,T2
      COMMON/DATAJ/S,B,XJ,YJ,ZJ,CABJ,SABJ,SALPJ,EXK,EYK,EZK,EXS,EYS,
     1 EZS,EXC,EYC,EZC,RKH,IND1,IND2,IPGND,IEXK
      COMMON/SEGJ/AX(30),BX(30),CX(30),JCO(30),JSNO,ISCON(50),NSCON,
     1 IPCON(10),NPCON
      DIMENSION CM(NROW,1),CW(NROW,1),ICON1(LD),ICON2(LD),ICONX(LD)
      DIMENSION EMEL(9)
      DIMENSION X(LD),Y(LD),Z(LD),BI(LD),SALP(LD)
      DIMENSION T1X(LD),T1Y(LD),T1Z(LD),T2X(LD),T2Y(LD),T2Z(LD)
      EQUIVALENCE (T1XJ,CABJ),(T1YJ,SABJ),(T1ZJ,SALPJ),(T2XJ,B),
     1 (T2YJ,IND1),(T2ZJ,IND2)
      DATA PI/3.141592654D0/
C**
C     E      WRITE(*,*) '   CMSW: START'
C**
      LDP=LD+1
      NEQS=N-N1+2*(M-M1)
      IF (ITRP.LT.0) GO TO 13
      K=0
      ICGO=1
C     OBSERVATION LOOP
      DO 12 I=I1,I2
      K=K+1
      XI=X(I)
      YI=Y(I)
      ZI=Z(I)
      CABI=T1Y(I)
      SABI=T1Z(I)
      SALPI=SALP(I)
      IPCH=0
      IF (ICON1(I).LT.10000) GO TO 1
      IPCH=ICON1(I)-10000
      FSIGN=-1.
1     IF (ICON2(I).LT.10000) GO TO 2
      IPCH=ICON2(I)-10000
      FSIGN=1.
2     JL=0
C     SOURCE LOOP
      DO 12 J=J1,J2
      JS=LDP-J
      JL=JL+2
      T1XJ=T1X(JS)
      T1YJ=T1Y(JS)
      T1ZJ=T1Z(JS)
      T2XJ=T2X(JS)
      T2YJ=T2Y(JS)
      T2ZJ=T2Z(JS)
      XJ=X(JS)
      YJ=Y(JS)
      ZJ=Z(JS)
      S=BI(JS)
C**
C     GROUND LOOP
      DO 12 IP=1,KSYMP
      IPGND=IP
      IF (IPCH.NE.J.AND.ICGO.EQ.1) GO TO 9
      IF (IP.EQ.2) GO TO 9
      IF (ICGO.GT.1) GO TO 6
      CALL PCINT (XI,YI,ZI,CABI,SABI,SALPI,EMEL)
      PY=PI*T1X(I)*FSIGN
      PX=SIN(PY)
      PY=COS(PY)
      EXC=EMEL(9)*FSIGN
      CALL TRIO(T1X,BI,ICON1,ICON2,I,LD)
      IF (I.GT.N1) GO TO 3
      IL=NEQS+ICONX(I)
      GO TO 4
3     IL=I-NCW
      IF (I.LE.NP) IL=((IL-1)/NP)*2*MP+IL
4     IF (ITRP.NE.0) GO TO 5
      CW(K,IL)=CW(K,IL)+EXC*(AX(JSNO)+BX(JSNO)*PX+CX(JSNO)*PY)
      GO TO 6
5     CW(IL,K)=CW(IL,K)+EXC*(AX(JSNO)+BX(JSNO)*PX+CX(JSNO)*PY)
6     IF (ITRP.NE.0) GO TO 7
      CM(K,JL-1)=EMEL(ICGO)
      CM(K,JL)=EMEL(ICGO+4)
      GO TO 8
7     CM(JL-1,K)=EMEL(ICGO)
      CM(JL,K)=EMEL(ICGO+4)
8     ICGO=ICGO+1
      IF (ICGO.EQ.5) ICGO=1
      GO TO 11
9      CONTINUE
      CALL UNERE (XI,YI,ZI)
      IF (ITRP.NE.0) GO TO 10
C     NORMAL FILL
      CM(K,JL-1)=CM(K,JL-1)+EXK*CABI+EYK*SABI+EZK*SALPI
      CM(K,JL)=CM(K,JL)+EXS*CABI+EYS*SABI+EZS*SALPI
      GO TO 11
C     TRANSPOSED FILL
10      CONTINUE
C**
      CM(JL-1,K)=CM(JL-1,K)+EXK*CABI+EYK*SABI+EZK*SALPI
      CM(JL,K)=CM(JL,K)+EXS*CABI+EYS*SABI+EZS*SALPI
11    CONTINUE
12    CONTINUE
C**
C     E      WRITE(*,*) '   CMSW: RETURN AFTER 12'
C**
      RETURN
C     FOR OLD SEG. CONNECTING TO OLD PATCH ON ONE END AND NEW SEG. ON
C     OTHER END INTEGRATE SINGULAR COMPONENT (9) OF SURFACE CURRENT ONLY
13    IF (J1.LT.I1.OR.J1.GT.I2) GO TO 16
      IPCH=ICON1(J1)
      IF (IPCH.LT.10000) GO TO 14
      IPCH=IPCH-10000
      FSIGN=-1.
      GO TO 15
14    IPCH=ICON2(J1)
      IF (IPCH.LT.10000) GO TO 16
      IPCH=IPCH-10000
      FSIGN=1.
15    IF (IPCH.GT.M1) GO TO 16
      JS=LDP-IPCH
      IPGND=1
      T1XJ=T1X(JS)
      T1YJ=T1Y(JS)
      T1ZJ=T1Z(JS)
      T2XJ=T2X(JS)
      T2YJ=T2Y(JS)
      T2ZJ=T2Z(JS)
      XJ=X(JS)
      YJ=Y(JS)
      ZJ=Z(JS)
      S=BI(JS)
      XI=X(J1)
      YI=Y(J1)
      ZI=Z(J1)
      CABI=T1Y(J1)
      SABI=T1Z(J1)
      SALPI=SALP(J1)
      CALL PCINT (XI,YI,ZI,CABI,SABI,SALPI,EMEL)
      PY=PI*T1X(J1)*FSIGN
      PX=SIN(PY)
      PY=COS(PY)
      EXC=EMEL(9)*FSIGN
      IL=JCO(JSNO)
      K=J1-I1+1
      CW(K,IL)=CW(K,IL)+EXC*(AX(JSNO)+BX(JSNO)*PX+CX(JSNO)*PY)
16      CONTINUE
C**
C     E      WRITE(*,*) '   CMSW: RETURN AT END'
C**
      RETURN
      END
C
C
C
      SUBROUTINE CMWS(CM,CW,X,Y,Z,BI,SALP,T1X,T1Y,T1Z,T2X,T2Y,T2Z,
     1 NR,NW,J,I1,I2,ITRP,LD)
C
C     CMWS COMPUTES MATRIX ELEMENTS FOR WIRE-SURFACE INTERACTIONS
C
      INTEGER*4 N1,N2,N,NP,M1,M2,M,MP,IPSYM,IND1,IND2,J,I1,I2,NR,NW
      REAL*8 XI,YI,ZI,AX,BX,CX
CLARGE: CM,CW
      COMPLEX CM,CW
      COMPLEX*16 ETK,ETS,ETC,EXK,EYK,EZK,EXS,EYS,EZS,EXC,EYC,EZC
      COMMON/DATAD/N1,N2,N,NP,M1,M2,M,MP,IPSYM,WLAM
      COMMON/SEGJ/AX(30),BX(30),CX(30),JCO(30),JSNO,ISCON(50),NSCON,
     1 IPCON(10),NPCON
      COMMON/DATAJ/S,B,XJ,YJ,ZJ,CABJ,SABJ,SALPJ,EXK,EYK,EZK,EXS,EYS,
     1 EZS,EXC,EYC,EZC,RKH,IND1,IND2,IPGND,IEXK
      DIMENSION  CM(NR,1), CW(NW,1)
      DIMENSION X(LD),Y(LD),Z(LD),BI(LD),SALP(LD)
      DIMENSION T1X(LD),T1Y(LD),T1Z(LD),T2X(LD),T2Y(LD),T2Z(LD)
C**
C     E      WRITE(*,*) '   CMWS: START'
C**
      LDP=LD+1
      S=T1X(J)
      B=BI(J)
      XJ=X(J)
      YJ=Y(J)
      ZJ=Z(J)
      CABJ=T1Y(J)
      SABJ=T1Z(J)
      SALPJ=SALP(J)
C
C     OBSERVATION LOOP
C
      IPR=0
      DO 9 I=I1,I2
      IPR=IPR+1
      IPATCH=(I+1)/2
      IK=I-(I/2)*2
      IF (IK.EQ.0.AND.IPR.NE.1) GO TO 1
      JS=LDP-IPATCH
      XI=X(JS)
      YI=Y(JS)
      ZI=Z(JS)
      CALL HSFLD (XI,YI,ZI,0.)
      IF (IK.EQ.0) GO TO 1
      TX=T2X(JS)
      TY=T2Y(JS)
      TZ=T2Z(JS)
      GO TO 2
1     TX=T1X(JS)
      TY=T1Y(JS)
      TZ=T1Z(JS)
2     ETK=-(EXK*TX+EYK*TY+EZK*TZ)*SALP(JS)
      ETS=-(EXS*TX+EYS*TY+EZS*TZ)*SALP(JS)
      ETC=-(EXC*TX+EYC*TY+EZC*TZ)*SALP(JS)
C
C     FILL MATRIX ELEMENTS.  ELEMENT LOCATIONS DETERMINED BY CONNECTION
C     DATA.
C
      IF (ITRP.NE.0) GO TO 4
C     NORMAL FILL
      DO 3 IJ=1,JSNO
      JX=JCO(IJ)
3     CM(IPR,JX)=CM(IPR,JX)+ETK*AX(IJ)+ETS*BX(IJ)+ETC*CX(IJ)
      GO TO 9
4     IF (ITRP.EQ.2) GO TO 6
C     TRANSPOSED FILL
      DO 5 IJ=1,JSNO
      JX=JCO(IJ)
5     CM(JX,IPR)=CM(JX,IPR)+ETK*AX(IJ)+ETS*BX(IJ)+ETC*CX(IJ)
      GO TO 9
C     TRANSPOSED FILL - C(WS) AND D(WS)PRIME (=CW)
6     DO 8 IJ=1,JSNO
      JX=JCO(IJ)
      IF (JX.GT.NR) GO TO 7
      CM(JX,IPR)=CM(JX,IPR)+ETK*AX(IJ)+ETS*BX(IJ)+ETC*CX(IJ)
      GO TO 8
7     JX=JX-NR
      CW(JX,IPR)=CW(JX,IPR)+ETK*AX(IJ)+ETS*BX(IJ)+ETC*CX(IJ)
8     CONTINUE
9     CONTINUE
C**
C     E      WRITE(*,*) '   CMWS: RETURN'
C**
      RETURN
      END
